/*
========================================================================
 Name        : AudioPlayerAppUi.h
 Copyright   : Symbian Academy, 2007
 Description : Creates default view, logic for handling events,
               owner of softkey/title/...-bar and views.
 =======================================================================
 */
#ifndef AUDIOPLAYERAPPUI_H
#define AUDIOPLAYERAPPUI_H

// [[[ begin generated region: do not modify [Generated Includes]
#include <aknviewappui.h>
// ]]] end generated region [Generated Includes]

// [[[ begin generated region: do not modify [Generated Forward Declarations]
class CAudioPlayerContainerView;
// ]]] end generated region [Generated Forward Declarations]

/**
 * @class	CAudioPlayerAppUi AudioPlayerAppUi.h
 * @brief The AppUi class handles application-wide aspects of the user interface, including
 *        view management and the default menu, control pane, and status pane.
 */
class CAudioPlayerAppUi : public CAknViewAppUi
	{
public: 
	// constructor and destructor
	CAudioPlayerAppUi();
	virtual ~CAudioPlayerAppUi();
	void ConstructL();

public:
	// from CCoeAppUi
	TKeyResponse HandleKeyEventL(
				const TKeyEvent& aKeyEvent,
				TEventCode aType );

	// from CEikAppUi
	void HandleCommandL( TInt aCommand );
	void HandleResourceChangeL( TInt aType );

	// from CAknAppUi
	void HandleViewDeactivation( 
			const TVwsViewId& aViewIdToBeDeactivated, 
			const TVwsViewId& aNewlyActivatedViewId );

private:
	void InitializeContainersL();
	// [[[ begin generated region: do not modify [Generated Methods]
public: 
	// ]]] end generated region [Generated Methods]
	
	// [[[ begin generated region: do not modify [Generated Instance Variables]
private: 
	CAudioPlayerContainerView* iAudioPlayerContainerView;
	// ]]] end generated region [Generated Instance Variables]
	
	
	// [[[ begin [User Handlers]
protected: 
	// ]]] end [User Handlers]
	
	};

#endif // AUDIOPLAYERAPPUI_H			
